frames = 100;
moviename = 'interp_gauss1d.avi';
mean1 = -2;
mean2 = 2;
std1 = 1;
std2 = .25;
w1 = 2;
w2 = .5;

t = [-4:.008:4];


for i = 1:frames,
    a = 1 - (i-1)/(frames-1);
    m = a*mean1 + (1-a)*mean2;
    std=a*std1 + (1-a)*std2;
    w = a*w1 + (1-a)*w2;
    plot(t(1:7:end),w*gauss(t(1:7:end),m,std),'k','LineWidth',3);
    axis off;
    set(gcf,'Color',[1 1 1]);
    M(i) = getframe(gcf);
end


%movie2avi(M,moviename,'FPS',frames/4,'Compression','Cinepak','Quality',100);
movie2avi(M,moviename,'FPS',60,'Compression','none','Quality',100);