t = [-4:.008:4];
%the input
figure;
data = cos(pi/8+ t/(0.75*pi))+2*gauss(t,2,.5)+0.5*gauss(t,2.1,1.5) + .2;
plot(t(1:7:end),data(1:7:end),'b','LineWidth',3);
hold on;

% gaussians
gs = @(x) (x(1)*gauss(t,x(2),x(3)) + x(4)*gauss(t,x(5),x(6)));
f1 = @(x) ((gs(x)-data)*(gs(x)-data)');
g1 = fminsearch(f1,[1,2,.5, 1,2.1,1.5]);
%plot(t(1:7:end),g1(1)*gauss(t(1:7:end),g1(2),g1(3)),'r--','LineWidth',3);
grecon = g1(1)*gauss(t,g1(2),g1(3)) + g1(4)*gauss(t,g1(5),g1(6));
plot(t(1:7:end),grecon(1:7:end),'r--','LineWidth',3);

plot(t(1:7:end),g1(1)*gauss(t(1:7:end),g1(2),g1(3)),'r--','LineWidth',1);
plot(t(1:7:end),g1(4)*gauss(t(1:7:end),g1(5),g1(6)),'r--','LineWidth',1);

axis off
set(gcf,'Color',[1 1 1]);

%nonlinear wavelets
figure;
plot(t(1:7:end),data(1:7:end),'b','LineWidth',3);
hold on;

[C,L] = wavedec(data,wmaxlev(size(data),'haar'),'haar');
[Y,I] = sort(abs(C));
C(find(abs(C) < Y(end-7))) = 0;
waverecon_nonlin = waverec(C,L,'haar');
plot(t(1:7:end),waverecon_nonlin(1:7:end),'r--','LineWidth',3);
axis off
set(gcf,'Color',[1 1 1]);

% linear wavelets
figure;
plot(t(1:7:end),data(1:7:end),'b','LineWidth',3);
hold on;

[C,L] = wavedec(data,wmaxlev(size(data),'haar'),'haar');
C(8:end) = 0;
waverecon = waverec(C,L,'haar');
plot(t(1:7:end),waverecon(1:7:end),'r--','LineWidth',3);
axis off
set(gcf,'Color',[1 1 1]);